#! /bin/sh
### BEGIN INIT INFO
# Provides:          mailman3
# Required-Start:    $remote_fs $syslog
# Required-Stop:     $remote_fs $syslog
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: Mailman3 server
# Description:       Starts and stops the Mailman3 server, used to
#                    manage mailing lists, queues, and all client queries
### END INIT INFO

# Do NOT "set -e"

# PATH should only include /usr/* if it runs after the mountnfs.sh script
PATH=/sbin:/usr/sbin:/bin:/usr/bin
DESC="Mailman3 program"
NAME=mailman3
DAEMON=/usr/bin/mailman
DAEMON_ARGS="-C /etc/mailman3/mailman.cfg start"
PIDDIR=/run/mailman3
PIDFILE=${PIDDIR}/master.pid
INTERPRETER=python3
RUNNER=/usr/lib/mailman3/bin/runner
SCRIPTNAME=/etc/init.d/$NAME
USER=list
GROUP=list

# Exit if the package is not installed
[ -x "$DAEMON" ] || exit 0

[ ! -d ${PIDDIR} ] && (mkdir -p ${PIDDIR} && chown ${USER}:${GROUP} ${PIDDIR})

# Read configuration variable file if it is present
[ -r $ENVIRONMENTFILE ] && . $ENVIRONMENTFILE

# Load the VERBOSE setting and other rcS variables
. /lib/init/vars.sh

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
# and status_of_proc is working.
. /lib/lsb/init-functions

#
# Function that starts the daemon/service
#
do_start() {
    # Return
    #   0 if daemon has been started
    #   1 if daemon was already running
    #   2 if daemon could not be started
    start-stop-daemon --start --quiet --pidfile $PIDFILE --exec "$(which $INTERPRETER)" \
        --test > /dev/null || return 1
    start-stop-daemon --start --quiet --pidfile $PIDFILE --chuid ${USER}:${GROUP} \
        --exec $DAEMON -- $DAEMON_ARGS || return 2
}

#
# Function that stops the daemon/service
#
do_stop() {
    # Return
    #   0 if daemon has been stopped
    #   1 if daemon was already stopped
    #   2 if daemon could not be stopped
    #   other if a failure occurred
    start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE \
        --user $USER --name $INTERPRETER
    RETVAL="$?"
    [ "$RETVAL" = 2 ] && return 2

    # Wait for children to finish too if this is a daemon that forks
    # and if the daemon is only ever run from this initscript.
    # If the above conditions are not satisfied then add some other code
    # that waits for the process to drop all resources that could be
    # needed by services started subsequently.  A last resort is to
    # sleep for some time.

    REMAINING_PIDS=`pgrep -f ${RUNNER}`

    if [ "$REMAINING_PIDS" ]; then
        for PID in $REMAINING_PIDS; do
            start-stop-daemon --stop --quiet --oknodo --retry 1 \
                --pid $PID --user $USER
        done
    fi

    # Many daemons don't delete their pidfiles when they exit.
    rm -f $PIDFILE

    return "$RETVAL"
}

#
# Function that sends a SIGHUP to the daemon/service
#
do_reload() {
    #
    # If the daemon can reload its configuration without
    # restarting (for example, when it is sent a SIGHUP),
    # then implement that here.
    #
    start-stop-daemon --stop --signal HUP --quiet --pidfile $PIDFILE --name $NAME
    return 0
}

case "$1" in
  start)
    [ "$VERBOSE" != "no" ] && log_daemon_msg "Starting $DESC" "$NAME"
    do_start
    case "$?" in
      0|1)
        [ "$VERBOSE" != "no" ] && log_end_msg 0
        ;;
      2)
        [ "$VERBOSE" != "no" ] && log_end_msg 1
        ;;
    esac
    ;;
  stop)
    [ "$VERBOSE" != "no" ] && log_daemon_msg "Stopping $DESC" "$NAME"
    do_stop
    case "$?" in
      0|1)
        [ "$VERBOSE" != "no" ] && log_end_msg 0
        ;;
      2)
        [ "$VERBOSE" != "no" ] && log_end_msg 1
        ;;
    esac
    ;;
  status)
    status_of_proc -p $PIDFILE $DAEMON $NAME && exit 0 || exit $?
    ;;
  reload|force-reload)
    log_daemon_msg "Reloading $DESC" "$NAME"
    do_reload
    log_end_msg $?
    ;;
  restart)
    log_daemon_msg "Restarting $DESC" "$NAME"
    do_stop
    case "$?" in
      0|1)
        do_start
        case "$?" in
          0)
            log_end_msg 0
            ;;
          1)
            # Old process is still running
            log_end_msg 1
            ;;
          *)
            # Failed to start
            log_end_msg 1
            ;;
        esac
        ;;
      *)
        # Failed to stop
        log_end_msg 1
        ;;
    esac
    ;;
  *)
    echo "$SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
    exit 3
    ;;
esac

exit 0
